<?php
/*
ftsaudit.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsaudit.php,v 1.10 2010/08/26 14:23:49 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsheader.php');

try {
  echo '<div class="filter">';
  $channel = $_GET['channel'];
  if (!isset($channel)) $channel = FTS_ALL;
  if ($channel != FTS_ALL && !isValidChannel($channel)) {
    throw new InvalidInputException("Not a valid channel name: $channel");
  }
  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
  echo 'Filter by ';
  $cl = new ChannelList();
  $cl->addAll();
  print ($cl->toHTML($channel));

  echo ' <input type="submit">';
  echo '</form>';
  echo '</div>';

  echo '<div class="principale">';
  echo "<h3>Modifications in the last 3 months</h3>";
  $query = "select CHANNEL_NAME, ADMIN_DN, " . getTimeInSql('MODIFICATION_TIME') . ", MESSAGE, CONTACT, BANDWIDTH, NOSTREAMS, NOFILES, TCP_BUFFER_SIZE, NOMINAL_THROUGHPUT, CHANNEL_STATE, SE_LIMIT, CHANNEL_TYPE, BLOCKSIZE, HTTP_TO, TX_LOGLEVEL, URLCOPY_PUT_TO, URLCOPY_PUTDONE_TO, URLCOPY_GET_TO, URLCOPY_GETDONE_TO, URLCOPY_TX_TO, URLCOPY_TXMARKS_TO, SRMCOPY_DIRECTION, SRMCOPY_TO, SRMCOPY_REFRESH_TO, TARGET_DIR_CHECK, URL_COPY_FIRST_TXMARK_TO, TRANSFER_TYPE, TX_TO_PER_MB, NO_TX_ACTIVITY_TO, PREPARING_FILES_RATIO";
  $query .= " from " . $ftsm->conf->connSchema . "T_AUDIT_CHANNEL ";
  $query .= " where MODIFICATION_TIME > sysdate - 90 ";
  if ($channel != FTS_ALL) { 
     $query .= " and CHANNEL_NAME = '" . $channel . "' ";
  }
  $query .= " order by MODIFICATION_TIME desc ";
  //echo $query;
  $ftsq->setQuery($query);
  $r = $ftsq->execute(3600);
  if ($r->getNbRows() == 0) {
      throw new Exception( "No modification found for $channel in the last 3 months");
  }
  $audits = Array();
  foreach ($r->getAllRows() as $row) {
    $modifs = Array();
    foreach ($row as $field=>$value) {
      if ($field != 'MESSAGE' && $field != 'MODIFICATION_TIME' && $field != 'AUDIT_ID' && $field != 'CHANNEL_NAME' && $field != 'ADMIN_DN' && $field != 'IP_ADDR' && $field != 'FTS_NODE') {
        if ($value != '') {
          $modifs[$field] = $value;
        }
      }
    }
    $auditline = Array();
    $auditline['MODIFIED'] = $row['MODIFICATION_TIME'];
    if ($channel == FTS_ALL) { 
      $auditline['CHANNEL_NAME'] = $row['CHANNEL_NAME'];
    }
    $auditline['MODIFICATION'] = $modifs;
    $auditline['MESSAGE'] = $row['MESSAGE'];
    $auditline['ADMIN_DN'] = $row['ADMIN_DN'];
    $audits[] = $auditline;
  }
  $qr = new FTS_QueryResult($audits);
  $qr->display('changes');
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
echo '</div>';
echo '</div>';
footer();
?>
