<?php
/*
ftschannel.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftschannel.php,v 1.43 2011/04/18 08:50:57 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

//$ftsdebug=True;
require_once('ftsheader.php');

if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';
//echo '<script language="JavaScript" type="text/javascript" src="jquery-1.4.2.min.js"></script>';

?>
  <link href="jquery/jquery-ui-1.8.2.custom.css" rel="stylesheet" type="text/css"/>
  <script src="jquery/jquery-1.4.2.min.js"></script>
  <script src="jquery/jquery-ui-1.8.2.custom.min.js"></script>
  
  <script>
  $(document).ready(function() {
    $("#tabs").tabs();
  });
  </script>

<?php

try {
  echo '<div class="filter">';
  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';

  $channel = $_GET['channel'];
  if (!isset($channel)) $channel=FTS_NONE;
  if (isset($channel) && !isValidChannel($channel)) {
    throw new InvalidInputException("not a valid channel name: $channel");
  }
  echo 'Filter by ';
  $cl = new ChannelList();
  $cl->addNone();
  print ($cl->toHTML($channel));
  echo ' for VO ';
  print ($ftsm->conf->voToHTML($vo));
?>
    <input type="submit">
</form>
</div>
<?php
  if (isset($channel)) { 
?>

<div id="tabs">
  <ul>
        <li><a href="#jobs"><span>Jobs</span></a></li>
<?php
  if ($channel != FTS_NONE) { 
?>

        <li><a href="#tr_stats"><span>Transfers stats</span></a></li>
        <li><a href="#err_stats"><span>Errors stats</span></a></li>
        <li><a href="#config"><span>Configuration</span></a></li>
<?php
  } 
?>
  </ul>
  <div id="jobs">
    <div id="activejobs" >
      <h4>Current jobs</h4>

      <?php  jobs();?>
    </div>

    <div id="endedjobs" >
      <h4>Ended jobs (finished in the last 24 hours)</h4>

      <?php  endedjobs();?>
    </div>
  </div>
<?php
  if ($channel != FTS_NONE) { 
?>
  <div id="tr_stats">
    <div style="float: left; height: 500">
      <h4>Last 24h activity</h4>
      <?php    files_and_throughput(); ?>
    </div>
    <div style="height: 500">
      <h4>Jobs (last 14 days)</h4>
      <?php  jobstats(); ?>
    </div>
  </div>
  <div id="err_stats">
    <div >
      <h4>Main errors (last 24 hours)</h4>
      <?php  errstats(); ?>
    </div>
  </div>
  <div id="config">
    <div >
      <h4>Parameters</h4>
      <?php  channelconfig(); ?>
    </div>
    <div >
      <h4>VO Share</h4>
      <?php  voshare(); ?>
    </div>
    <div >
      <h4>Managers</h4>
      <?php  managers(); ?>
    </div>
  </div>
<?php
  } 
?>
</div>


<?php
 } //ENDIF Channel is not None
?>

<?php
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}

function channelconfig() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select SOURCE_SITE, DEST_SITE, T_CHANNEL.CONTACT, NOSTREAMS, NOFILES, CHANNEL_STATE, " . getTimeInSql('T_CHANNEL.LAST_ACTIVE') . ", ADMIN_DN, AGENT_HOST ";
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $query .= ", TRANSFER_TYPE, decode(TRANSFER_TYPE, 'URLCOPY', URLCOPY_TX_TO, SRMCOPY_TO) as TRANSFER_TIMEOUT, TCP_BUFFER_SIZE ";
      if ($ftsm->conf->currentSchema >= "3.3.0") {
        $query .= ", TX_TO_PER_MB ";
      }
    }
    $query .= " from " . $ftsm->conf->connSchema . "T_CHANNEL, " . $ftsm->conf->connSchema . "T_AGENT where AGENT_NAME = 'channel:" . $channel . "' AND CHANNEL_NAME = '" . $channel . "'";
    $ftsq->setQuery($query);
    //print $query;
    $r = $ftsq->execute();
 //   ftsSyslog(sprintf("EXECUTED %s IN %d s\n", $query, $ftsq->duration),LOG_DEBUG);
    if ($r->getNbRows() == 0) {
      throw new Exception( "This channel does not exist: $channel");
    }
    $channelFound = $r->getFirstRow();
    //print "<ul>";
    printf("Between <b>%s</b> and <b>%s</b>", $channelFound['SOURCE_SITE'], $channelFound['DEST_SITE']);
    $g = $ftsm->getGroup($channelFound['SOURCE_SITE']);
    if (!is_null($g)) {
        print $g->toHTML();
    }
    $g = $ftsm->getGroup($channelFound['DEST_SITE']);
    if (!is_null($g)) {
        print $g->toHTML();
    }
    printf("<br><b>%s</b> concurrent files on <b>%s</b> streams each", $channelFound['NOFILES'], $channelFound['NOSTREAMS']);
    printf(" - TCP buffer size: <b>%s</b>", $channelFound['TCP_BUFFER_SIZE']);
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $toVariable = '';
      if ($ftsm->conf->currentSchema >= "3.3.0") {
        $toVariable = $channelFound['TX_TO_PER_MB'] != ''?
		" + " . $channelFound['TX_TO_PER_MB'] . " s/MB"
		:"";
      }
      printf("<br>Transfer timeout (%s): <b>%s sec %s</b>\n", 
	$channelFound['TRANSFER_TYPE'], 
	($channelFound['TRANSFER_TIMEOUT'] != ''?$channelFound['TRANSFER_TIMEOUT']:"NOT DEFINED"),
        $toVariable);
    }
    printf("<br>The channel is <b>%s</b> (latest start: <b>%s</b>)", $channelFound['CHANNEL_STATE'], $channelFound['LAST_ACTIVE']);
    printf("<br>Agent running on <b>%s</b>", $channelFound['AGENT_HOST']);
    printf("<br><a href=\"ftsaudit.php?channel=%s\">Go to history of channel management</a>", $channel);
}

function voshare() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    if ($ftsm->conf->currentSchema >= "3.2.0") {
      $selectWhat = " CHANNEL_SHARE, CHANNEL_LIMIT, CHANNEL_VOSTATE ";
    } else {
      $selectWhat = " CHANNEL_SHARE ";
    }
    if ($vo == FTS_ALL) {
      $selectWhat = " VO_NAME, " . $selectWhat;
    }
    $query = "select " . $selectWhat . "  from " . $ftsm->conf->connSchema . "T_CHANNEL_VO_SHARE where CHANNEL_NAME = '" . $channel . "' ";
    if ($vo != FTS_ALL) {
      $query .= " and VO_NAME = '" . $vo . "'";
    } else {
      $query .= " order by VO_NAME";
    }
    //print $query;
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
  //  ftsSyslog(sprintf("EXECUTED %s IN %d s\n", $query, $ftsq->duration), LOG_DEBUG);
    $r->display();
}

function managers() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select PRINCIPAL as CHANNEL_MANAGERS from " . $ftsm->conf->connSchema . "T_CHANNEL_ACL where CHANNEL_NAME = '" . $channel . "'";
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    $r->display();
}

function errstats() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $concat = "t_transfer.error_scope || ' / ' || t_transfer.error_phase || ' / ' || t_transfer.reason_class";
    /*
    $query = "select count(" . $concat . ") as nb_errors, " . $concat . " AS ERROR_TYPE ";
    $query .= " from " . $ftsm->conf->connSchema . "t_transfer, " . $ftsm->conf->connSchema . "t_job, " . $ftsm->conf->connSchema . "t_file ";
    $query .= " where t_file.finish_time between (sysdate - 1) and sysdate ";
    $query .= " and t_transfer.job_id = t_job.job_id ";
    $query .= " and t_transfer.file_id = t_file.file_id ";
    $query .= " and t_file.job_id = t_job.job_id ";
    $query .= "  and t_transfer.transfer_state = '" . FTS_STATE_FAILED . "' ";
    $query .= "  and channel_name = '" . $channel . "'";
    if ($vo != FTS_ALL) {
        $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " group by (" . $concat . ") order by nb_errors desc";
    */
    $query = "select count(" . $concat . ") as nb_errors, " . $concat . " AS ERROR_TYPE ";
    $query .= " from " . $ftsm->conf->connSchema . "t_transfer ";
    if ($vo != FTS_ALL) {
    	$query .= ", " . $ftsm->conf->connSchema . "t_job ";
    }
    // we use job_finished because finish_time is null
    $query .= " where t_transfer.job_finished >= (sysdate - 1) ";
    if ($vo != FTS_ALL) {
    	$query .= " and t_transfer.job_id = t_job.job_id ";
    }
    $query .= "  and t_transfer.transfer_state = '" . FTS_STATE_FAILED . "' ";
    $query .= "  and t_transfer.request_id like '" . $channel . "%'";
    if ($vo != FTS_ALL) {
        $query .= " and t_job.vo_name = '" . $vo . "' ";
    }
    $query .= " group by (" . $concat . ") order by nb_errors desc";
    
    $ftsq->setQuery($query);
    //echo $query;
    $r = $ftsq->execute(3600);
    $r->setMaxLines(5);
    try {
    	$r->setQuery($query);
      $r->displayPie('ERROR_TYPE','NB_ERRORS');
    } catch (Exception $e) {
      $r->display();
    }
}

function jobstats() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select JOB_STATE, count(JOB_ID) as NUMBER_OF_JOBS ";
    $query .= " from " . $ftsm->conf->connSchema . "T_JOB ";
    $query .= " where CHANNEL_NAME = '" . $channel . "' ";
    if ($vo != FTS_ALL) {
	    $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and SUBMIT_TIME between (sysdate - 14) and sysdate group by JOB_STATE ";
    $query .= " order by JOB_STATE";
    $ftsq->setQuery($query);
    //print $query;
    $r = $ftsq->execute(3600);
    $current_channel = new ChannelStat($channel);
    foreach ($r->getAllRows() as $row) {
        $current_channel->setStat($row['JOB_STATE'], (int)($row['NUMBER_OF_JOBS']));
    }
    try {
      printf("%s", $current_channel->toPie(600));
    } catch (Exception $e) {
      echo "<table cellpadding=\"2\" border=\"1\">\n";
      print "<TR>";
      print "<th class=\"layout\" width=\"50%\">";
      foreach ($ftsm->getStates() as $state) {
        printf("<span class=\"%s\"> %s </span>", $state, $state);
      }
      print "</th></TR>\n";
      
      printf( "<TR><TD>%s</TD></TR>", $current_channel->toString());
      echo "</TR></table>\n";
    }
}

function endedjobs() {
  jobs(False);
}

function jobs($active=True) {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select T_JOB.JOB_ID, " . getTimeInSql('T_JOB.SUBMIT_TIME') . ", decode(CANCEL_JOB, 'Y', '" . FTS_STATE_CANCELING . "', JOB_STATE) AS JOB_STATE, ";
    if (!$active) {
    	$query .= " decode(JOB_STATE, '" . FTS_STATE_FINISHED_DIRTY . "', JOB_STATE || ' (' || ";
    	$query .= " (select TO_CHAR(count(FILE_ID)) from " . $ftsm->conf->connSchema . "T_FILE where JOB_ID = T_JOB.JOB_ID and FILE_STATE = '" . FTS_STATE_FAILED . "') ";
    	$query .= " || '/' || ";
    	$query .= " (select TO_CHAR(count(FILE_ID)) from " . $ftsm->conf->connSchema . "T_FILE where JOB_ID = T_JOB.JOB_ID)";
    	$query .= " || ')', JOB_STATE) AS JOB_STATE, ";
    }
    if ($vo == FTS_ALL) {
        $query .= " VO_NAME, ";
    }
    $query .= " SOURCE_SE, DEST_SE, STORAGE_CLASS ";
    $query .= " from " . $ftsm->conf->connSchema . "T_JOB ";
    if (isset($channel) and $channel != FTS_NONE) {
        $query .= " where CHANNEL_NAME = '" . $channel . "' ";
    } else {
        $query .= " where CHANNEL_NAME is null";
    }
    if ($vo != FTS_ALL) {
         $query .= " and VO_NAME = '" . $vo . "' ";
    }
    if ($active) {
      $query .= " and T_JOB.JOB_FINISHED is null ";
      $query .= " order by SUBMIT_TIME asc";
    } else {
      $query .= " and (T_JOB.JOB_FINISHED > sysdate - 1)";
      $query .= " order by T_JOB.JOB_FINISHED desc";
    }
    $ftsq->setQuery($query);
    if ($active) {
    	$r = $ftsq->execute(-1);
    } else {
    	$r = $ftsq->execute(3600);
    }
    $jdr = new FTS_JobDetailsResult($r->getAllRows());
    // the ID of the table is either "activejobdetail" or "endedjobdetail"
    $jdr->display($active?"activejobdetail":"endedjobdetail");
}

function files_and_throughput() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    if ($ftsm->conf->time_utc) {
      $query = "select TO_CHAR(FROM_TZ(SYS_EXTRACT_UTC(T_transfer.transfer_TIME)),'HH24') as h, ";
    } else {
      $query = "select TO_CHAR(T_transfer.transfer_TIME AT TIME ZONE sessiontimezone,'HH24') as h, ";
    }
    //$query .= " bytes_written, tx_duration ";
    $query .= " COUNT(transfer_id) as nb_files, SUM(bytes_written) as total_bytes, SUM(tx_duration) as total_duration ";
    $query .= " from " . $ftsm->conf->connSchema . "t_job, " . $ftsm->conf->connSchema . "t_transfer";
    $query .= " where t_transfer.transfer_TIME > (sysdate - 1) ";
    $query .= " and T_transfer.transfer_state = '" . FTS_STATE_COMPLETED . "'";
    if ($vo != FTS_ALL) {
         $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and T_JOB.CHANNEL_NAME = '" . $channel . "' ";
    $query .= " and T_TRANSFER.JOB_ID = T_JOB.JOB_ID ";
    $query .= " group by TO_CHAR(T_transfer.transfer_TIME AT TIME ZONE sessiontimezone,'HH24') "; //order by TO_CHAR(T_transfer.transfer_TIME AT TIME ZONE sessiontimezone,'HH24');
    //$query .= " order by T_TRANSFER.TRANSFER_TIME";
    //print $query;
    $ftsq->setQuery($query);
    $r = $ftsq->execute(3600);
    $results = $r->getAllRows();
    $nrows = $r->getNbRows();
    // store results in Array starting from H-23: nbFiles[8=>[12,355000000,245], 9=>[25,455000000,234]...]
    // Triplet is [nbfiles,nbbytes,duration in sec]
    $nbFiles = Array();
     if ($ftsm->conf->time_utc) {
      $currenthour = gmdate('H');
    } else {
      $currenthour = date('H');
    }
     // Init this array with 0
    for ($i = $currenthour; $i <= 23; $i++) {
        $nbFiles[sprintf("%dh",$i)] = Array(0,0,0);
    }
    for ($i = 0; $i < $currenthour; $i++) {
        $nbFiles[sprintf("%dh",$i)] = Array(0,0,0);
    }
    foreach ($results as $row) {
      $hourOfTransfer = (int)$row['H'];
      $hourIndex = sprintf("%dh",$hourOfTransfer);
      /*
      $nbFiles[$hourIndex][0]++;
      $nbFiles[$hourIndex][1] += (int)$row['BYTES_WRITTEN'];
      $nbFiles[$hourIndex][2] += (int)$row['TX_DURATION'];
		*/
      $nbFiles[$hourIndex][0] = (int)$row['NB_FILES'];
      $nbFiles[$hourIndex][1] = (double)$row['TOTAL_BYTES'];
      $nbFiles[$hourIndex][2] = (int)$row['TOTAL_DURATION'];
    }
     // print files transfers statistics

    $nbdata = Array();
    $trdata = Array();
    foreach ($nbFiles as $index=>$f) {
      $nbdata[$index] = $f[0]; //array(8,3,16,2,7,25,16);
      if ($f[2] > 0) {
        $trdata[$index] = $f[1]/$f[2]/(1024.0*1024);
      } else {
        $trdata[$index] = 0;
      }
    }

	 //echo"<br>tr_data=";
	 //var_dump($trdata);
	 
    try { // if jpgraph is installed
      if( !function_exists("imagetypes") || !function_exists('imagecreatefromstring') ) throw new Exception("GD is not installed");
      if (!file_exists($ftsm->conf->jpgraph_path . "/src/jpgraph.php")) throw new Exception("JPGraph is not installed");
      require_once ($ftsm->conf->jpgraph_path . "/src/jpgraph.php");
      include_once ($ftsm->conf->jpgraph_path . "/src/jpgraph_bar.php");
      //include_once ($ftsm->conf->jpgraph_path . "/src/jpgraph_line.php");
      //$graphFileNameNb = ftsCacheGetImgName($query . '-nb-jpgraph');
      $plotCacheObj = new CacheImg($query . '-nb-jpgraph');
      //if (!file_exists($graphFileNameNb) || filemtime($graphFileNameNb)<time()-$plotLifeTime) {
      if (! $plotCacheObj->isCached()) {
        // Creation du graphique
        $graph = new Graph(700,200);
        $graph->SetScale("textlin");
        $graph->title->Set("Number of files");
        $graph->xaxis->SetTickLabels(array_keys($nbdata));

        // Création du système de points
        //$lineplot=new LinePlot(array_values($nbdata));
        $lineplot=new BarPlot(array_values($nbdata));

        // On rajoute les points au graphique
        $graph->Add($lineplot);

        // Save file and cache
        $graph->Stroke($plotCacheObj->getFileName());
      }
      //echo "<tr><td colspan='26'>\n";
      printf("<img src='%s'/>", $plotCacheObj->getFileName());
      //echo "</td></tr>";
      // Throughput graph
      $plotCacheObj = new CacheImg($query . '-tr-jpgraph');
      if (! $plotCacheObj->isCached()) {
        // Creation du graphique
        $graph = new Graph(700,200);
        $graph->SetScale("textlin");
        $graph->title->Set("Average throughput in MiB/s");
        $graph->xaxis->SetTickLabels(array_keys($nbdata));

        // Création du système de points
        $lineplot=new BarPlot(array_values($trdata));
        //$lineplot->Legend($graph);

        // On rajoute les points au graphique
        $graph->Add($lineplot);

        // Save file and cache
        $graph->Stroke($plotCacheObj->getFileName());
      }
      //echo "<tr><td colspan='26'>\n";
      printf("<br><img src='%s'/>", $plotCacheObj->getFileName());
      //echo "</td></tr>";

    } catch (Exception $e) {
      echo "<table><tr>";
      echo "<th>Hour</th>\n";
      foreach ($nbFiles as $index=>$f) {
        printf("<th>%s</th>", $index);
      }
      echo "<th>Total</th></tr>\n";
      echo "<tr><td>Nb of files</td>";
      foreach($nbdata as $v) {
        printf("<td>%d</td>", $v);
      }
      printf("<td>%d</td>\n", $nrows);
      echo "</tr>\n";
      echo "<tr><td>Avg MiB/s</td>";
      foreach($trdata as $v) {
        printf("<td>%d</td>", $v);
      }
      printf("<td></td>\n");
      echo "</tr>\n";
      echo "</table>\n";
    }


}


function files() {
    global $ftsq;
    global $ftsm;
    global $vo;
    global $channel;
    $query = "select TO_CHAR(T_FILE.FINISH_TIME,'HH24') as h from " . $ftsm->conf->connSchema . "T_JOB, " . $ftsm->conf->connSchema . "T_FILE ";
    $query .= " where T_FILE.FINISH_TIME > (sysdate - 1) ";
    $query .= " and T_FILE.FILE_STATE = '" . FTS_STATE_FINISHED . "'";
    if ($vo != FTS_ALL) {
         $query .= " and VO_NAME = '" . $vo . "' ";
    }
    $query .= " and T_JOB.CHANNEL_NAME = '" . $channel . "' ";
    $query .= " and T_FILE.JOB_ID = T_JOB.JOB_ID ";
    $query .= " order by T_FILE.FINISH_TIME";
    //print $query;
    $ftsq->setQuery($query);
    $r = $ftsq->execute();
    $results = $r->getAllRows();
    $nrows = $r->getNbRows();
    // store results in Array starting from H-23: nbFiles[8=>12, 9=>25...]
    $nbFiles = Array();
    // Init this array with 0
    for ($i = 0; $i <= 23; $i++) {
      $nbFiles[] = 0;
    }
    $currenthour = date('H');
    foreach ($results as $row) {
      $hourOfTransfer = (int)$row['H'] + 2;  // FTS is 2 hour late
      if ($hourOfTransfer > $currenthour) 
          $hourIndex = $hourOfTransfer - $currenthour - 1;
      else
          $hourIndex = 23 - $currenthour + $hourOfTransfer;
      $nbFiles[$hourIndex]++;
    }
    //var_dump($nbFiles);

    echo "<table><tr>";
    for ($i = $currenthour; $i <= 23; $i++) {
        printf("<th>%02d</th>", $i);
    }
    for ($i = 0; $i < $currenthour; $i++) {
        printf("<th>%02d</th>", $i);
    }
    echo "<th>Total</th></tr>\n";
    // print files transfers statistics
    echo "<tr>";
    /*for ($i = $currenthour; $i <= 23; $i++) {
        printf("<td>%d</td>", $nbFiles[$i]);
    }
    for ($i = 0; $i < $currenthour; $i++) {
        printf("<td>%d</td>", $nbFiles[$i]);
    }*/
    foreach($nbFiles as $v) {
        printf("<td>%d</td>", $v);
    }
    printf("<td>%d</td>\n", $nrows);
    echo "</tr>\n";

    try { // if jpgraph is installed
      if( !function_exists("imagetypes") || !function_exists('imagecreatefromstring') ) throw new Exception("GD is not installed");
      if (!file_exists($ftsm->conf->jpgraph_path . "/src/jpgraph.php")) throw new Exception("JPGraph is not installed");
      include_once ($ftsm->conf->jpgraph_path . "/src/jpgraph.php");
      include_once ($ftsm->conf->jpgraph_path . "/src/jpgraph_line.php");
      //$graphFileName = ftsCacheGetImgName($query . '-jpgraph');
      $plotCacheObj = new CacheImg($query . '-jpgraph');
      //if (!file_exists($graphFileName) || filemtime($graphFileName)<time()-$plotLifeTime) {
      if (! $plotCacheObj->isCached()) {
        $ydata = $nbFiles; //array(8,3,16,2,7,25,16);

        // Creation du graphique
        $graph = new Graph(700,100);
        $graph->SetScale("textlin");
        $graph->xaxis->Hide();

        // Création du système de points
        $lineplot=new LinePlot($ydata);

        // On rajoute les points au graphique
        $graph->Add($lineplot);

        // Save file and cache
        $graph->Stroke($plotCacheObj->getFileName());
      }
      echo "<tr><td colspan='25'>\n";
      printf("<img src='%s'/>", $plotCacheObj->getFileName());
      echo "</td></tr>";
    } catch (Exception $e) {
    }
    echo "</table>\n";


}
echo '</div>';
footer();
?>