<?php
/*
ftsfile.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftsfile.php,v 1.14 2010/08/26 14:23:49 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsheader.php');
if (strpos($_SERVER['HTTP_USER_AGENT'], 'Safari')) {
  echo '<script language="JavaScript" type="text/javascript" src="detail-safari.js">';
} else {
  echo '<script language="JavaScript" type="text/javascript" src="detail.js">';
}
echo '</script>';

?>

<?php
try {
  echo '<div class="filter">';
  $surl = $_GET['surl'];
  /*if (!isValidSurl($surl)) {
    throw new Exception("This is not a valid SURL: $surl");
  }*/
  $surl = getValidSurl($surl);

  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
  echo ' Source SURL: <input name="surl" value="' . $surl . '" size="100">';
  echo ' <input type="submit">';
  echo '</form>';
  echo '</div>';

    echo '<div class="principale">';
    echo "<h3>Transfers (last 24h)</h3>";
    $query = "select T_TRANSFER.REQUEST_ID, T_FILE.FILE_ID, T_FILE.JOB_ID, T_FILE.FILE_STATE, " . getTimeInSql('T_FILE.FINISH_TIME') . ", T_FILE.FILESIZE, round(decode(TX_DURATION, 0, 0, BYTES_WRITTEN/TX_DURATION)) AS THROUGHPUT,  DEST_SURL, T_FILE.ERROR_SCOPE, T_TRANSFER.TRANSFER_STATE, T_FILE.REASON, 'DUMMY' as LOG  from " . $ftsm->conf->connSchema . "T_FILE LEFT OUTER JOIN " . $ftsm->conf->connSchema . "T_TRANSFER ON T_FILE.FILE_ID = T_TRANSFER.FILE_ID where T_FILE.SOURCE_SURL = '" . $surl . "'";
    $query .= " and (T_FILE.FINISH_TIME > sysdate - 1) and (T_TRANSFER.TRANSFER_TIME > sysdate - 1)";
    $query .= " order by T_FILE.FINISH_TIME desc";
    //echo $query;
    $ftsq->setQuery($query);
    $r = $ftsq->execute(1800);
    // Those columns display depending on various values
    $r->hide('REASON');
    $r->hide('ERROR_SCOPE');
    $r->hide('THROUGHPUT');
    foreach ($r->getAllRows() as $row) {
        if ($row['REASON'] != '') $r->show('REASON');
        if ($row['ERROR_SCOPE'] != '') $r->show('ERROR_SCOPE');
        if ($row['FILE_STATE'] != 'Failed') $r->show('THROUGHPUT');
    }
    $r->hide('REQUEST_ID');
    $r->hide('TRANSFER_STATE');
    $r->hide('FILE_STATE');
    $r->display('jobdetail');
} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
echo '</div>';
footer();
?>
