<?php
/*
ftslog.php
Copyright (C) 2008,2009,2010 IN2P3, CNRS

This file is part of Ftsmonitor.

Ftsmonitor is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Ftsmonitor is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Ftsmonitor; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/*
VERSION: '$Id: ftslog.php,v 1.2 2010/06/17 16:26:09 schwarz Exp $';
AUTHOR: Lionel Schwarz (lionel.schwarz@in2p3.fr)
*/

require_once('ftsheader.php');

try {
  echo '<div class="filter">';
  $transfer_id = $_GET['transfer_id'];
  if (!isValidTransferId($transfer_id)) {
    throw new InvalidInputException("Not a valid FTS transfer ID: $transfer_id");
  }

  $status = $_GET['status'];
  if (!isValidTransferState($status)) {
    throw new InvalidInputException("Not a valid FTS transfer state: $status");
  }

  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="get">';
  echo 'Display log of Transfer ID: ';
  echo '<INPUT type="text" size="40" name="transfer_id"  onChange="javascript:this.form.submit();" value="' . $transfer_id . '"/>';

  echo ' in state <select name="status" onChange="javascript:this.form.submit();">';
  foreach (Array(FTS_STATE_COMPLETED,FTS_STATE_FAILED) as $state) {
    printf ("<option value=\"%s\" %s>%s", $state, $state==$status?"selected":"", $state);
  }
  echo '           </select>';

  echo '  <input type="submit">';
  echo '</form>';
  echo '</div>';
  
  if (! is_null($ftsm->log_viewer)) {
    $log = $ftsm->log_viewer->getLog('NULL',$transfer_id,$status);
    if (! is_null($log)) {
      print $log->toHTML();
    }
  } else {
    echo 'The log viewer is not enabled, please check the configuration file';
  }

} catch (Exception $e) {
  die('<span class="' . FTS_CSS_CLASS_ALERT . '">ERROR: --' . $e->getMessage() . '--</span>');
}
echo '</div>';
footer();
?>